/*
 *	Copyright (C) 1997 Advanced Research Laboratory, Hitachi, Ltd.
 *	Author: Shingo NISHIOKA
 *		nis@harl.hitachi.co.jp
 */

/* static char rcsid[] = "$Id: killeonp.c,v 1.6 2001/09/06 06:23:20 nis Exp $"; */

#include <sys/param.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <strings.h>

#include <geta/smap.h>

#define	BSIZE	8192

char *progname;

main(argc, argv)
char *argv[];
{
	static char buf[BSIZE];
	int fold = 0;

	if (progname = rindex(argv[0], '/')) {
		progname++;
	}
	else {
		progname = argv[0];
	}

	for (argc--, argv++; argc>0; argc--, argv++) {
		if (!strcmp(*argv, "-f") || !strcmp(*argv, "-fold")) {
			fold = 1;
		}
		else {
			fprintf(stderr, "Usage: %s [-f|-fold]\n", progname);
			exit(1);
		}
	}

	for (; fgets(buf, sizeof buf, stdin); ) {
		char *p;
		for (p=buf; p=strstr(p, END_OF_NP); ) {
			memset(p, ' ', sizeof END_OF_NP-1);
		}
		if (fold) {
			for (p=buf; p=index(p, ' '); ) {
				*p++ = '\n';
			}
		}
		fputs(buf, stdout);
		fflush(stdout);
	}
	return 0;
}
