#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <stdlib.h>

#define MAXCHARBYTE 7   /* HDHgai: 6   + 1*/

main(argc, argv) int argc; char *argv[];
{char *name="s2l";
 char *usage="{+hdhgaiji}";
 int  i, c, s;
 unsigned char b[MAXCHARBYTE];
 int readchar();
 int Fhdhgai=0;
 i = 0;
 while (++i < argc)
   {if      (! strcmp(argv[i],"+hdhgaiji")){Fhdhgai = 1;}
    else {fprintf (stderr, "usage: %s %s\n", name, usage);
	  return(-1);};};
 while((c = readchar(b,&s,Fhdhgai)) != EOF)
   {if (s == -1){printf("o:\\000");}
    else if (s <= 0)
      {printf("o:");
       for (i=0; b[i]; ++i)
	 {if (b[i] < 010) {printf("\\00%o", b[i]);}
          else if (b[i] < 0100) {printf("\\0%o", b[i]);}
	  else {printf("\\%o", b[i]);};};}
    else {printf("c:%s", b);};
    printf("\n");
    fflush(stdout);};
 return(0);}

int readchar(b,ps,Fhdhgai) unsigned char b[]; int *ps, Fhdhgai;
{int c = getchar();
 if (c == EOF) {*ps = -1; b[0] = '\0';}
 else if (isascii(c))
   {b[0] = c; b[1] = '\0';
    if (isspace(c)) {*ps = 0;}
    else if (isdigit(c)) {*ps = 11;}
    else if (isalpha(c)) {*ps = 12;}
    else if (isprint(c)) {*ps = 13;}
    else {*ps = -10;};}
 else if (iseucj1(c))
   {b[0] = c;
    if(iseucj2(c = getchar()))
      {b[1] = c; b[2] = '\0';
       if(iseucDigit(b[0],b[1])) {*ps = 21;}
       else if(iseucAlpha(b[0],b[1])) {*ps = 22;}
       else if(iseucHiragana(b[0],b[1])) {*ps = 23;}
       else if(iseucKatakana(b[0],b[1])) {*ps = 24;}
       else if(iseucGreek(b[0],b[1])) {*ps = 25;}
       else if(iseucRussian(b[0],b[1])) {*ps = 26;}
       else if(iseucKanji(b[0],b[1])) {*ps = 27;}
       else {*ps = 28;};}
    else {*ps = -2; b[0] = '\0';};}
 else if (Fhdhgai && ishdhgai1(c))
   {b[0] = c;
    if(iseucj2(c = getchar()))
      {b[1] = c;
       if (ishdhgai2(c = getchar()))
	 {b[2] = c;
	  if(iseucj2(c = getchar()))
	    {b[3] = c;
	     if (ishdhgai3(c = getchar()))
	       {b[4] = c;
		if(iseucj2(c = getchar()))
		  {b[5] = c; b[6] = '\0';
		   *ps = 27;}
		else {b[5] = c; b[6] = '\0'; *ps = -50;};}
	     else if (iseucj2(c))
	       {b[4] = c; b[5] = (c = getchar()); *ps = -50;}
	     else {b[4] = '\0'; *ps = -50;};}
	  else {b[3] = c; b[4] = '\0'; *ps = -50;};}
       else if (iseucj2(c))
	 {b[2] = c; b[3] = (c = getchar()); *ps = -50;}
       else {b[2] = '\0'; *ps = -50;};}
    else {b[1] = c; b[2] = '\0'; *ps = -50;};}
 else if (iseucj2(c))
   {b[0] = c; b[1] = getchar(); b[2] = '\0'; *ps = -2;}
 else {*ps = -2; b[0] = '\0';};
 return(c);}

iseucj1(c) int c; {return((0xA1 <= c)  && (c <= 0xF4));}
iseucj2(c) int c; {return((0xA1 <= c)  && (c <= 0xFE));}

iseucDigit(c1, c2) int c1, c2;
{return((c1 == 0xA3) && (c2 >= 0xB0) && (c2 <= 0xB9));}
iseucAlpha(c1, c2) int c1, c2;
{return((c1 == 0xA3) && (c2 >= 0xC1) && (c2 <= 0xFA));}
iseucHiragana(c1, c2) int c1, c2;
{return((c1 == 0xA4) && (c2 >= 0xA1) && (c2 <= 0xF3));}
iseucKatakana(c1, c2) int c1, c2;
{return(((c1 == 0xA5) && (c2 >= 0xA1) && (c2 <= 0xF6)) ||
        ((c1 == 0xA1) && (c2 == 0xBC)));}
iseucGreek(c1, c2) int c1, c2;
{return((c1 == 0xA6) && (c2 >= 0xA1) && (c2 <= 0xD8));}
iseucRussian(c1, c2) int c1, c2;
{return((c1 == 0xA7) && (c2 >= 0xA1) && (c2 <= 0xF1));}
iseucKanji(c1, c2) int c1, c2;
{return(((c1 >= 0xB0) && (c1 <= 0xF4) && (c2 >= 0xA1) && (c2 <= 0xFE)) ||
        ((c1 == 0xA1) && (c2 == 0xB9)));}

ishdhgai1(c) int c; {return (c == 0xFB);}
ishdhgai2(c) int c; {return (c == 0xFC);}
ishdhgai3(c) int c; {return (c == 0xFD);}

print_help()
{fprintf (stderr, "Options:\n");
 fprintf (stderr, "  +hdhgaiji: Flag for hdh-gaiji input ON\n");
 fprintf (stderr, "  (otherwise, hdh-gaiji is treated as un-expected\n");
 fprintf (stderr, "   characters, and not output\n");
 return(0);}
