/*
 *	Copyright (C) 1998 Advanced Research Laboratory, Hitachi, Ltd.
 *	Author: Shingo NISHIOKA
 *		nis@harl.hitachi.co.jp
 */

/* static char rcsid[] = "$Id: ifsmap.h,v 1.1.1.1 2000/07/28 00:26:45 nis Exp $"; */

#ifndef _GEMU_IFSMAP_H
#define _GEMU_IFSMAP_H

struct ps {
	char *p;
	char escs[5];
	char *d;	/* only used by breakpoint */
};

int smap_setup(int *, int);
int smap_set_lang(char *);
int smap_start_text(void);
void smap_send_to_analyser(char *);
int smap_count_ndllines(char *);
void smap_get_phrase(struct ps *, char *, int, int);
char *smap_skip_spaces_jis(char *);
ssize_t smap_readln(char *, size_t);

#endif
