/*
 *	Copyright (C) 1998 Advanced Research Laboratory, Hitachi, Ltd.
 *	Author: Shingo NISHIOKA
 *		nis@harl.hitachi.co.jp
 */

/* static char rcsid[] = "$Id: ssP.h,v 1.3 2001/05/07 06:51:12 nis Exp $"; */

#define	SMAP_FN_ACCESSFILE	"/etc/ss.access"
#define	SMAP_FN_CONFIGFILE	"/etc/ss.conf"
#define	SMAP_FN_RUNFILE		"/var/run/ss.pid"

#include <geta/smap.h>
#include <geta/srvmu.h>

/* commands.c */
void do_server(int);

/* ana.c */
void analyse(char *, int, struct _lang_conf *, int);

/* do_split.c */
void do_split(void);

/* uniform.c */
int split1(char *, size_t, char *);
int splitn(char *, size_t, char *);
int stemn(char *, size_t, char *);
int ngramn(char *, size_t, char *);
int chasenn(char *, size_t, char *);
int animar(char *, size_t, char *);
int def_filt(char *, size_t, char *);

/* tmu.c */
void setlead(char *);
void tt(char *);

/* main.c */
void sstate(char *);

/* ssconfig.c */
int readconf(char *, char *);
int lcompar(const void *va, const void *vb);
