/*
 *	Copyright (C) 1999 Hitachi, Ltd.
 *	All rights reserved.
 *	Author: Shingo NISHIOKA
 *		nis@harl.hitachi.co.jp
 */

/* static char rcsid[] = "$Id: perp.c,v 1.3 2001/02/06 08:44:22 nis Exp $"; */

#include <stdio.h>
#include <string.h>
#include <strings.h>

#include <geta/getamu.h>

char *progname;

main(argc, argv)
char *argv[];
{
	char *tag, buf[8192];

	if (progname = rindex(argv[0], '/')) {
		progname++;
	}
	else {
		progname = argv[0];
	}

	if (argc!=2) {
		fprintf(stderr, "usage: %s tag\n", progname);
		exit(1);
	}

	tag = argv[1];

	while (fgets(buf, sizeof buf, stdin)) {
		fputs(buf, stdout);
		fflush(stdout);
		chop(buf);
		fprintf(stderr, "%s: [%s]\n", tag, buf);
	}
	return 0;
}
