/*
 *	Copyright (C) 1998 Advanced Research Laboratory, Hitachi, Ltd.
 *	Author: Shingo NISHIOKA
 *		nis@harl.hitachi.co.jp
 */

/* static char rcsid[] = "$Id: smap.h,v 1.2 2000/10/06 01:51:13 nis Exp $"; */

#ifndef _GEMU_SMAP_H
#define _GEMU_SMAP_H

#define	IBUFSIZE	65536
#define	MAXNWORDS	IBUFSIZE
#define	FULLWORDSIZE	(IBUFSIZE/4*18+1)

#define MAXWORDLEN	256

struct _lang_conf {
	char *language;
	char *start;
	void (*analyse)(void);
	int (*uniform)(char *, size_t, char *);
	int fds[2];
	int semidx;
	pid_t pid;	/* for debug */
};

#define	CDOT	'.'
#define	DOT	"."
#define	CR	"\015"
#define	LF	"\012"
#define	CRLF	CR LF
#define	CSEP	'\034'
#define	SEP	"\034"

#define	D_SSTATE	1	/* debug_info: sstate */
#define	D_LOGINPUT	2	/* debug_info: sstate */

#define	END_OF_NP	"<end-of-NP>"

#endif
